;nyquist plug-in
;version 4
;type process
;name "Helmet Radio 1.4..."
;action "Processing ..."
;author "Steve Daulton and Trebor"
;copyright "Released under terms of the GNU General Public License version 2"

;; This version is identical to 1.3 but with a syntax correction to the controls of lopas and hipas.
;; Paul2 (13 January 2022).

;control helmet-size "Helmet size" float "" 444 200 1000
;control reflect "Helmet refectivity" float "" 0.75 0 2
;control voice-crackle "Voice crackle" float "" 0.01 0 .2
;control hiss "Constant hiss" float "" 0.02 0 1
;control crackle "Constant crackle" float "" 0.02 0 .5
;control klip "Clipping" float "" 2 0 20
;control lopas "Low pass" float "(Hz)" 4000 1000 14000
;control hipas "High pass" float "(Hz)" 300 20 1000


"convert helmet-size, so bigger helmet has lower comb frequency" 
(setf helmet-size  (- 1200 helmet-size))

"convert klip, so it is never less than 1" 
(setf  klip  (+ 1 klip))


(defun helmet-echo (sig)
"Simulate acoustics inside helmet."
  (lowpass16
    (sum (mult reflect (reflected sig))
         (highpass16 sig hipas))
    lopas))

(defun reflected (sig)
"Comb filter effect to simulate acoustic reflections inside helmet"
  (lowpass2
    (highpass16 (comb sig 0.03 helmet-size) hipas)
    lopas))


;;; Helper functions:

(defun lowpass16 (sig hz)
  (lowpass8 (lowpass8 sig hz) hz))

(defun highpass16 (sig hz)
  (highpass8 (highpass8 sig hz) hz))


;;; Noise generators:

(defun radio-crackle (sig)
(mult voice-crackle (noise) (noise) (noise) *track*))

(defun hissNcrackle (sig)
(sum
(lowpass2 (mult hiss (noise) (noise) (noise) (noise) (noise) (noise))2000)
(mult crackle (noise) (noise) (noise)(noise) (noise) (noise) (noise) (noise) (noise) (noise)))) 


(sum (hissNcrackle *track*)(radio-crackle *track*)
     (lowpass8 (mult (sum 1 (/ klip 10))
(clip (mult klip (helmet-echo *track*)) (/ klip))) 
  lopas)) 